PGraphics pend;
PGraphics menuL;
PGraphics graf;

PFont fontButton;
PFont fonte1;

PImage zeroJoule;
PImage duzJoule;
PImage processing;
PImage desenergia;
PImage corpoprova1;
PImage inicial;
PImage setas;
PImage energia1;
PImage grafico1;

FloatNumberBox temperaturaBanho;
FloatNumberBox temperaturaPeca;
FloatNumberBox energiaAbs;


Pendulo Pend1 = new Pendulo();
Button go;
Button pausa;
Button replay;
Button comecarTutorial;
Button avancart;
Button sobreGraf;
Button comecarTeste;
Button inicio;
Button irTutorial;
Button retornarTeste;
Button credito;
Button avancarref;
Button voltarcred;
Button avancari;

float arot;                          
float offset = -9*PI/12.0;   
float angulo;
float teta=0;

float angfinal=1;

float posgoX=180;
float posgoY=610;
float larggo=80;
float compgo=40;

float tbanho=0.0;
float tpeca=0.0;

float energia=0.0;
float enAbs=0.0;

float tempoparado=0;
float tempop=0;

int tecla;
int marcador=1;
int controlevolta=0;
int casover=1;
int controleinicial=-1;

boolean goB=false;
boolean flaggo=false;
boolean flagpausa=false;
boolean flagmarcador=false;
boolean flaggraf=false;
boolean goGraf=false;
boolean pausaB=true;
boolean estadoreplay=false;
boolean flagpeca=false;
boolean goTutorial=false;
boolean flaginicio=false;
boolean flagcredito=false;
boolean goCredito=false;
boolean flagref=false;
boolean goRef=false;
boolean tutorial=true;
boolean golink=false;
boolean flagvoltcred=false;
boolean flagenergia=false;
boolean flagcprova=false;
boolean flagalertatemp=false;
boolean liberar = false;

void setup() 
{ 
  size(900, 665);
  pend = createGraphics (840,600,P3D);
  menuL = createGraphics (350,700,P2D);
  graf = createGraphics (280,160,P2D);
  fonte1 = loadFont("ArialMT-48.vlw");
  fontButton = loadFont("ArialUnicodeMS-28.vlw");
  processing=loadImage("processing.png");
  zeroJoule = loadImage("zerojoule.png");
  duzJoule = loadImage("duzjoule.png");
  desenergia = loadImage("energia.png");
  corpoprova1 = loadImage("corpoprova1.png");
  inicial = loadImage("inicio2.PNG");
  setas = loadImage("setas.png");
  energia1 = loadImage("energia1.png");
  grafico1= loadImage ("grafico.PNG");
  temperaturaPeca = new FloatNumberBox(175, 240, 70, 23, 1.0, 2, 200, -200, 0.01, 1, 1, 1.0/8.0, color(255));
  temperaturaBanho = new FloatNumberBox(175, 195, 70, 23, 1.0, 2, 200, -200, 0.01, 1, 1, 1.0/8.0, color(255));
  energiaAbs = new FloatNumberBox(140, 305, 70, 23, 1.0, 2, 200, 0, 0.01, 1, 1, 1.0/8.0, color(255));

  comecarTutorial = new Button (400,470,150,40,20, "Ajuda");
  retornarTeste = new Button (650,470,150,40,19, "Teste");
  comecarTeste = new Button (180,600,150,40,20, "Começar teste");
  sobreGraf = new Button (600,630,225,25,20, "Transição Dúctil - Frágil");
  go = new Button (posgoX,posgoY,larggo,compgo,25, ">>");
  avancart = new Button (800,posgoY,larggo,compgo,25, ">>");
  avancari = new Button (760,450,70,35,25, ">>");
  pausa = new Button (posgoX,posgoY,larggo,compgo,25, "Pausa");
  replay = new Button (posgoX,posgoY,larggo+17,compgo,20, "Novo teste");
  inicio = new Button (635,628,60,25,20, "Início");
  irTutorial = new Button (730,628,80,25,20, "Ajuda");
  credito = new Button (800,20,80,30,20, "Créditos");
  avancarref = new Button (680,560,60,30,25, ">>");
  voltarcred = new Button (680,560,60,30,25, "<<");
}

void draw() {

  background(0);
println(mouseX);
println(mouseY);

  tempo=millis();
  tempop=millis();
  if(tbanho>tpeca) {
    imagemcontrole=2;
  }
  if(tbanho<tpeca) {
    imagemcontrole=1;
  }
  if(tpeca<tbanho+0.04&&tpeca>tbanho-0.04) {
    imagemcontrole=0;
  }

  if(tbanho!=tpeca) {
    controlTemperaturaP();
  }

  if(abs(tpeca-tbanho)<0.08) {
    flagalertatemp=false;
  }

  if(flaginicio==true&&liberar==true) {
    goTutorial=true;
    
  }


  if(flaggraf==true&&mousePressed==false) {
    goGraf=true;
    flaggraf=false;
  }

          
  if(flagref==true&&mousePressed==false) {
    flagref=false;
    casover=2;
  }

  if(flagvoltcred==true&&mousePressed==false) {
    casover=1;
    flagvoltcred=false;
  }

  if(golink==true&&mousePressed==false) {
    golink=false;
    link("http://processing.org");
  }

  if(flagcredito==true) {
    goCredito=true;
    flagcredito=false;
  }

  if(goCredito==true) {
    funcaoVerMais(casover);
  }

  else {
    if(goTutorial==false) {
      funcaoVerMais(controleinicial);
      if(controleinicial==-1) {
        avancari.mostrar();
      }
      if(controlevolta==0) {
        if(controleinicial==0) {
          comecarTutorial.mostrar();
          retornarTeste.mostrar();
        }
      }
      else {
        comecarTutorial.mostrar();
        retornarTeste.mostrar();
      }
      if(flagenergia==true) {
        funcaoVerMais(3);
      }
      if(flagcprova==true) {
        funcaoVerMais(4);
      }
      if(goGraf==true) {
            funcaoVerMais(10);
          }
    }

    else {

      if(tutorial==true) {


        if(flagmarcador==true&&mousePressed==false) {
          marcador++;
          flagmarcador=false;
        }

        if(marcador==1) {

          Pend1.update(offset);
          image(pend, 70,50); 
          fill(255);
          textSize(20);
          text("Para mudar o ângulo \nde visualização do \nequipamento, clique e \narraste o mouse pela tela", 150, 100);
          avancart.mostrar();
          fill(0,0,255);
          textSize(18);
          //text("Pular ajuda", 847, 10);
          //strokeWeight(1);
          //stroke(0,0,255);
          //line(795,22,900,22);
        }


        if(marcador==2) {
          stroke(190);
          fill(0);
          rect(530,30,350,590);
          menul();
          image(menuL,530,30);
          fill(255);
          textSize(20);
          image(setas, 155, 220);
          text("Para controlar a temperatura do \n banho, utilizar as teclas \ndirecionais do teclado.", 250, 120);
          //text("Para cima: + 0.1°C\nPara baixo: - 0.1°C\n  Para direita: + 1.0°C\n      Para esquerda: - 1.0°C", 250, 300);
          text("Quando a temperatura da peça\n atingir a temperatura do banho,\n a peça pode ser liberada para o \nensaio clicando sobre ela.", 250, 480);
          textSize(15);
          text("- 0.1°C",255,376);
          text("+ 0.1°C",255,232);
          text("- 1.0°C",134,335);
          text("+ 1.0°C",375,335);

          comecarTeste.mostrar();
          sobreGraf.mostrar();
          fill(0,0,255);
          textSize(18);
          //text("Pular ajuda", 847, 10);
          //strokeWeight(1);
          //stroke(0,0,255);
          //line(795,22,900,22);

          if(goGraf==true) {
            funcaoVerMais(10);
          }
        }

        if(marcador>2) {
          tbanho=0;
          tpeca=0;
          teta=0;
          tutorial=false;
          flagpeca=false;
        }
      }

      else {
        if (mousePressed==false&&flaggo==true) {
          goB=true;
          pausaB=false;
          flaggo=false;
        }
        if (mousePressed==false&&flagpausa==true) {
          goB=false;
          pausaB=true;
          flagpausa=false;
        }
        if(goB==true&&(arot+offset)<angfinal) {
          arot += 0.03;
        }

        angulo=arot+offset;

        Pend1.update(angulo);
        image(pend,-100,0);
        if(xpeca==0) {
          fill(255);
          textSize(16);
          text("Corpo de prova colocado\n e pronto para ensaio", 370,625);
        }

        if(goB==false&&xpeca<=0) {
          go.mostrar();
        }


        if(pausaB==false) {
          pausa.mostrar();
        }
        if((arot+offset)>=angfinal) {
          goB=true;
          pausaB=true;

          if(flagpeca==true) {
            enAbs=energia;
            graf.beginDraw();
            graf.stroke(0);
            graf.strokeWeight(4);
            graf.point(((tbanho+120)*280/320), 160-(enAbs/120)*160);
            graf.endDraw();
          }
          replay.mostrar();
          estadoreplay=true;
        }
        fill(0,200);
        rect(530,30,350,590);
        menul();
        image(menuL, 530,30);

        inicio.mostrar();
        irTutorial.mostrar();
      }
    }
  }
  if(arot==0) {
    if(tempop-tempoparado>500&&tpeca>tbanho-0.01&&tpeca<tbanho+0.01&&flaggopeca==false) {
      noLoop();
    }
  }
  if((arot+offset)>=angfinal) {
    if(tempop-tempoparado>4000&&tpeca>tbanho-0.01&&tpeca<tbanho+0.01) {
      noLoop();
    }
  }

}
void mouseMoved() {
  loop();
  tempoparado=tempop;
}

void mouseDragged() {
  loop();
  tempoparado=tempop;
  //if(goTutorial==true) {
  teta=teta-(((mouseX-pmouseX)*2*PI)/400);
  //}
}


void mousePressed() {
  loop();
  tempoparado=tempop;
  if(goCredito==true) {
    if(casover==1) {
      if(mouseX>710&&mouseX<730&&mouseY>110&&mouseY<130) {
        goCredito=false;
        flagcredito=false;
      }

      if(mouseX>325&&mouseX<385&&mouseY>334&&mouseY<400) {
        golink=true;
      }

      if(mouseX>680&&mouseX<740&&mouseY>560&&mouseY<590) {
        flagref=true;
      }
    }
    if(casover==2) {
      if(mouseX>680&&mouseX<740&&mouseY>560&&mouseY<590) {
        flagvoltcred=true;
      }
      if(mouseX>710&&mouseX<730&&mouseY>110&&mouseY<130) {
        goCredito=false;
        casover=1;
      }
    }
  }

  if(controleinicial==-1&&mouseX>760&&mouseX<830&&mouseY>450&&mouseY<485) {
    controleinicial=0;
  }

  if(flagenergia==true&&mouseX>710&&mouseX<730&&mouseY>90&&mouseY<110) {
    
    flagenergia=false;
  }

  if(flagcprova==true&&mouseX>790&&mouseX<810&&mouseY>80&&mouseY<100) {
    flagcprova=false;
  }

  if(goGraf==true&&mouseX>790&&mouseX<810&&mouseY>80&&mouseY<100) {
    goGraf=false;
  }

  if(flagcprova==true&&mouseX>347&&mouseX<678&&mouseY>348&&mouseY<367) {
    flagcprova=false;
  }

  if(flaginicio==false&&goCredito==false) {
    if(mouseX>400&&mouseX<550&&mouseY>470&&mouseY<510&&goTutorial==false&&liberar==true) {
      flaginicio=true;
    }

    if(mouseX>585&&mouseX<740&&mouseY>310&&mouseY<325&&flagenergia==false&&liberar==true) {
      flagenergia=true;
          }
    
    if(flaggraf==false&&mouseX>450&&mouseX<548&&mouseY>410&&mouseY<427&&liberar==true) {
      flaggraf=true;
    }

    if(flagcprova==false&&mouseX>560&&mouseX<700&&mouseY>337&&mouseY<352&&liberar==true) {
      flagcprova=true;
    }
    if(mouseX>800&&mouseX<880&&mouseY>20&&mouseY<50&&goCredito==false) {
      flagcredito=true;
      casover=1;
    }
  }

  else {

    if(tutorial==true) {

      if(mouseX>800&&mouseX<width&&mouseY>0&&mouseY<23) {
        marcador=3;
      }

      if(mouseX>800&&mouseX<800+larggo&&mouseY>posgoY&&mouseY<posgoY+compgo&&flagmarcador==false&&marcador==1) {
        flagmarcador=true;
      }

      if(mouseX>180&&mouseX<330&&mouseY>600&&mouseY<640&&flagmarcador==false&&marcador==2) {
        flagmarcador=true;
      }

      if(mouseX>600&&mouseX<825&&mouseY>630&&mouseY<655&&marcador==2&&flaggraf==false) {
        flaggraf=true;
      }

      if(mouseX>596&&mouseX<645&&mouseY>110&&mouseY<125&&tpeca<tbanho+0.02&&tpeca>tbanho-0.02&&arot==0) { //liberarpeçatutorial
        flagpeca=true;
      }
    }

    else {

      if(mouseX>635&&mouseX<695&&mouseY>628&&mouseY<653) {
        goTutorial=false;
        flaginicio=false;
        marcador=1;
        controlevolta=1;
      }

      if(mouseX>730&&mouseX<810&&mouseY>628&&mouseY<653&&liberar==true) {
        tutorial=true;
        marcador=1;
      }

      if(mouseX>posgoX&&mouseX<posgoX+larggo&&mouseY>posgoY&&mouseY<posgoY+compgo&&goB==false&&xpeca<=0) {
        flaggo=true;
        
        energia=57.717+59.939*( ( exp((tpeca+2.166)/60) - exp(-(tpeca+2.166)/60) ) / ( exp((tpeca+2.166)/60) + exp (-(tpeca+2.166)/60) ) );
        if(energia>5) {
          energia= energia+random(-3,3);
        }
        if(flagpeca==false) {
          energia=0;
        }

        angfinal=(8*PI/12)*(1-(energia/200));
      }
      if(mouseX>posgoX&&mouseX<posgoX+larggo&&mouseY>posgoY&&mouseY<posgoY+compgo&&pausaB==false) {
        flagpausa=true;
      }
      if(mouseX>posgoX&&mouseX<posgoX+larggo+17&&mouseY>posgoY&&mouseY<posgoY+compgo&&estadoreplay==true) {

        estadoreplay=false;
        goB=false;
        arot=0;
        ypeca=0;
        xpeca=50;
        ang2=0;
        flagpeca=false;
        enAbs=0;
      }

      if(mouseX>595&&mouseX<645&&mouseY>110&&mouseY<125&&tpeca<tbanho+0.02&&tpeca>tbanho-0.02&&arot==0) { //liberarpeça
        flagpeca=true;
      }
      if(mouseX>665&&mouseX<715&&mouseY>110&&mouseY<125&&abs(tpeca-tbanho)>0.02&&arot==0) {
        flagalertatemp=true;
      }
    }
  }
}

void keyPressed() {
  loop();
  tempoparado=tempop;
  if(goTutorial==true) {
    if (key == CODED) {
      tecla=keyCode;
      controlTemperaturaB(tecla);
    }
  }
}

