import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class pendulo3d6 extends PApplet {

PGraphics pend;
PGraphics menuL;
PGraphics graf;

PFont fontButton;
PFont fonte1;

PImage zeroJoule;
PImage duzJoule;
PImage processing;
PImage desenergia;
PImage corpoprova1;
PImage inicial;
PImage setas;
PImage energia1;
PImage grafico1;

FloatNumberBox temperaturaBanho;
FloatNumberBox temperaturaPeca;
FloatNumberBox energiaAbs;


Pendulo Pend1 = new Pendulo();
Button go;
Button pausa;
Button replay;
Button comecarTutorial;
Button avancart;
Button sobreGraf;
Button comecarTeste;
Button inicio;
Button irTutorial;
Button retornarTeste;
Button credito;
Button avancarref;
Button voltarcred;
Button avancari;

float arot;                          
float offset = -9*PI/12.0f;   
float angulo;
float teta=0;

float angfinal=1;

float posgoX=180;
float posgoY=610;
float larggo=80;
float compgo=40;

float tbanho=0.0f;
float tpeca=0.0f;

float energia=0.0f;
float enAbs=0.0f;

float tempoparado=0;
float tempop=0;

int tecla;
int marcador=1;
int controlevolta=0;
int casover=1;
int controleinicial=-1;

boolean goB=false;
boolean flaggo=false;
boolean flagpausa=false;
boolean flagmarcador=false;
boolean flaggraf=false;
boolean goGraf=false;
boolean pausaB=true;
boolean estadoreplay=false;
boolean flagpeca=false;
boolean goTutorial=false;
boolean flaginicio=false;
boolean flagcredito=false;
boolean goCredito=false;
boolean flagref=false;
boolean goRef=false;
boolean tutorial=true;
boolean golink=false;
boolean flagvoltcred=false;
boolean flagenergia=false;
boolean flagcprova=false;
boolean flagalertatemp=false;
boolean liberar = false;

public void setup() 
{ 
  size(900, 665);
  pend = createGraphics (840,600,P3D);
  menuL = createGraphics (350,700,P2D);
  graf = createGraphics (280,160,P2D);
  fonte1 = loadFont("ArialMT-48.vlw");
  fontButton = loadFont("ArialUnicodeMS-28.vlw");
  processing=loadImage("processing.png");
  zeroJoule = loadImage("zerojoule.png");
  duzJoule = loadImage("duzjoule.png");
  desenergia = loadImage("energia.png");
  corpoprova1 = loadImage("corpoprova1.png");
  inicial = loadImage("inicio2.PNG");
  setas = loadImage("setas.png");
  energia1 = loadImage("energia1.png");
  grafico1= loadImage ("grafico.PNG");
  temperaturaPeca = new FloatNumberBox(175, 240, 70, 23, 1.0f, 2, 200, -200, 0.01f, 1, 1, 1.0f/8.0f, color(255));
  temperaturaBanho = new FloatNumberBox(175, 195, 70, 23, 1.0f, 2, 200, -200, 0.01f, 1, 1, 1.0f/8.0f, color(255));
  energiaAbs = new FloatNumberBox(140, 305, 70, 23, 1.0f, 2, 200, 0, 0.01f, 1, 1, 1.0f/8.0f, color(255));

  comecarTutorial = new Button (400,470,150,40,20, "Ajuda");
  retornarTeste = new Button (650,470,150,40,19, "Teste");
  comecarTeste = new Button (180,600,150,40,20, "Come\u00e7ar teste");
  sobreGraf = new Button (600,630,225,25,20, "Transi\u00e7\u00e3o D\u00factil - Fr\u00e1gil");
  go = new Button (posgoX,posgoY,larggo,compgo,25, ">>");
  avancart = new Button (800,posgoY,larggo,compgo,25, ">>");
  avancari = new Button (760,450,70,35,25, ">>");
  pausa = new Button (posgoX,posgoY,larggo,compgo,25, "Pausa");
  replay = new Button (posgoX,posgoY,larggo+17,compgo,20, "Novo teste");
  inicio = new Button (635,628,60,25,20, "In\u00edcio");
  irTutorial = new Button (730,628,80,25,20, "Ajuda");
  credito = new Button (800,20,80,30,20, "Cr\u00e9ditos");
  avancarref = new Button (680,560,60,30,25, ">>");
  voltarcred = new Button (680,560,60,30,25, "<<");
}

public void draw() {

  background(0);
println(mouseX);
println(mouseY);

  tempo=millis();
  tempop=millis();
  if(tbanho>tpeca) {
    imagemcontrole=2;
  }
  if(tbanho<tpeca) {
    imagemcontrole=1;
  }
  if(tpeca<tbanho+0.04f&&tpeca>tbanho-0.04f) {
    imagemcontrole=0;
  }

  if(tbanho!=tpeca) {
    controlTemperaturaP();
  }

  if(abs(tpeca-tbanho)<0.08f) {
    flagalertatemp=false;
  }

  if(flaginicio==true&&liberar==true) {
    goTutorial=true;
    
  }


  if(flaggraf==true&&mousePressed==false) {
    goGraf=true;
    flaggraf=false;
  }

          
  if(flagref==true&&mousePressed==false) {
    flagref=false;
    casover=2;
  }

  if(flagvoltcred==true&&mousePressed==false) {
    casover=1;
    flagvoltcred=false;
  }

  if(golink==true&&mousePressed==false) {
    golink=false;
    link("http://processing.org");
  }

  if(flagcredito==true) {
    goCredito=true;
    flagcredito=false;
  }

  if(goCredito==true) {
    funcaoVerMais(casover);
  }

  else {
    if(goTutorial==false) {
      funcaoVerMais(controleinicial);
      if(controleinicial==-1) {
        avancari.mostrar();
      }
      if(controlevolta==0) {
        if(controleinicial==0) {
          comecarTutorial.mostrar();
          retornarTeste.mostrar();
        }
      }
      else {
        comecarTutorial.mostrar();
        retornarTeste.mostrar();
      }
      if(flagenergia==true) {
        funcaoVerMais(3);
      }
      if(flagcprova==true) {
        funcaoVerMais(4);
      }
      if(goGraf==true) {
            funcaoVerMais(10);
          }
    }

    else {

      if(tutorial==true) {


        if(flagmarcador==true&&mousePressed==false) {
          marcador++;
          flagmarcador=false;
        }

        if(marcador==1) {

          Pend1.update(offset);
          image(pend, 70,50); 
          fill(255);
          textSize(20);
          text("Para mudar o \u00e2ngulo \nde visualiza\u00e7\u00e3o do \nequipamento, clique e \narraste o mouse pela tela", 150, 100);
          avancart.mostrar();
          fill(0,0,255);
          textSize(18);
          //text("Pular ajuda", 847, 10);
          //strokeWeight(1);
          //stroke(0,0,255);
          //line(795,22,900,22);
        }


        if(marcador==2) {
          stroke(190);
          fill(0);
          rect(530,30,350,590);
          menul();
          image(menuL,530,30);
          fill(255);
          textSize(20);
          image(setas, 155, 220);
          text("Para controlar a temperatura do \n banho, utilizar as teclas \ndirecionais do teclado.", 250, 120);
          //text("Para cima: + 0.1\u00b0C\nPara baixo: - 0.1\u00b0C\n  Para direita: + 1.0\u00b0C\n      Para esquerda: - 1.0\u00b0C", 250, 300);
          text("Quando a temperatura da pe\u00e7a\n atingir a temperatura do banho,\n a pe\u00e7a pode ser liberada para o \nensaio clicando sobre ela.", 250, 480);
          textSize(15);
          text("- 0.1\u00b0C",255,376);
          text("+ 0.1\u00b0C",255,232);
          text("- 1.0\u00b0C",134,335);
          text("+ 1.0\u00b0C",375,335);

          comecarTeste.mostrar();
          sobreGraf.mostrar();
          fill(0,0,255);
          textSize(18);
          //text("Pular ajuda", 847, 10);
          //strokeWeight(1);
          //stroke(0,0,255);
          //line(795,22,900,22);

          if(goGraf==true) {
            funcaoVerMais(10);
          }
        }

        if(marcador>2) {
          tbanho=0;
          tpeca=0;
          teta=0;
          tutorial=false;
          flagpeca=false;
        }
      }

      else {
        if (mousePressed==false&&flaggo==true) {
          goB=true;
          pausaB=false;
          flaggo=false;
        }
        if (mousePressed==false&&flagpausa==true) {
          goB=false;
          pausaB=true;
          flagpausa=false;
        }
        if(goB==true&&(arot+offset)<angfinal) {
          arot += 0.03f;
        }

        angulo=arot+offset;

        Pend1.update(angulo);
        image(pend,-100,0);
        if(xpeca==0) {
          fill(255);
          textSize(16);
          text("Corpo de prova colocado\n e pronto para ensaio", 370,625);
        }

        if(goB==false&&xpeca<=0) {
          go.mostrar();
        }


        if(pausaB==false) {
          pausa.mostrar();
        }
        if((arot+offset)>=angfinal) {
          goB=true;
          pausaB=true;

          if(flagpeca==true) {
            enAbs=energia;
            graf.beginDraw();
            graf.stroke(0);
            graf.strokeWeight(4);
            graf.point(((tbanho+120)*280/320), 160-(enAbs/120)*160);
            graf.endDraw();
          }
          replay.mostrar();
          estadoreplay=true;
        }
        fill(0,200);
        rect(530,30,350,590);
        menul();
        image(menuL, 530,30);

        inicio.mostrar();
        irTutorial.mostrar();
      }
    }
  }
  if(arot==0) {
    if(tempop-tempoparado>500&&tpeca>tbanho-0.01f&&tpeca<tbanho+0.01f&&flaggopeca==false) {
      noLoop();
    }
  }
  if((arot+offset)>=angfinal) {
    if(tempop-tempoparado>4000&&tpeca>tbanho-0.01f&&tpeca<tbanho+0.01f) {
      noLoop();
    }
  }

}
public void mouseMoved() {
  loop();
  tempoparado=tempop;
}

public void mouseDragged() {
  loop();
  tempoparado=tempop;
  //if(goTutorial==true) {
  teta=teta-(((mouseX-pmouseX)*2*PI)/400);
  //}
}


public void mousePressed() {
  loop();
  tempoparado=tempop;
  if(goCredito==true) {
    if(casover==1) {
      if(mouseX>710&&mouseX<730&&mouseY>110&&mouseY<130) {
        goCredito=false;
        flagcredito=false;
      }

      if(mouseX>325&&mouseX<385&&mouseY>334&&mouseY<400) {
        golink=true;
      }

      if(mouseX>680&&mouseX<740&&mouseY>560&&mouseY<590) {
        flagref=true;
      }
    }
    if(casover==2) {
      if(mouseX>680&&mouseX<740&&mouseY>560&&mouseY<590) {
        flagvoltcred=true;
      }
      if(mouseX>710&&mouseX<730&&mouseY>110&&mouseY<130) {
        goCredito=false;
        casover=1;
      }
    }
  }

  if(controleinicial==-1&&mouseX>760&&mouseX<830&&mouseY>450&&mouseY<485) {
    controleinicial=0;
  }

  if(flagenergia==true&&mouseX>710&&mouseX<730&&mouseY>90&&mouseY<110) {
    
    flagenergia=false;
  }

  if(flagcprova==true&&mouseX>790&&mouseX<810&&mouseY>80&&mouseY<100) {
    flagcprova=false;
  }

  if(goGraf==true&&mouseX>790&&mouseX<810&&mouseY>80&&mouseY<100) {
    goGraf=false;
  }

  if(flagcprova==true&&mouseX>347&&mouseX<678&&mouseY>348&&mouseY<367) {
    flagcprova=false;
  }

  if(flaginicio==false&&goCredito==false) {
    if(mouseX>400&&mouseX<550&&mouseY>470&&mouseY<510&&goTutorial==false&&liberar==true) {
      flaginicio=true;
    }

    if(mouseX>585&&mouseX<740&&mouseY>310&&mouseY<325&&flagenergia==false&&liberar==true) {
      flagenergia=true;
          }
    
    if(flaggraf==false&&mouseX>450&&mouseX<548&&mouseY>410&&mouseY<427&&liberar==true) {
      flaggraf=true;
    }

    if(flagcprova==false&&mouseX>560&&mouseX<700&&mouseY>337&&mouseY<352&&liberar==true) {
      flagcprova=true;
    }
    if(mouseX>800&&mouseX<880&&mouseY>20&&mouseY<50&&goCredito==false) {
      flagcredito=true;
      casover=1;
    }
  }

  else {

    if(tutorial==true) {

      if(mouseX>800&&mouseX<width&&mouseY>0&&mouseY<23) {
        marcador=3;
      }

      if(mouseX>800&&mouseX<800+larggo&&mouseY>posgoY&&mouseY<posgoY+compgo&&flagmarcador==false&&marcador==1) {
        flagmarcador=true;
      }

      if(mouseX>180&&mouseX<330&&mouseY>600&&mouseY<640&&flagmarcador==false&&marcador==2) {
        flagmarcador=true;
      }

      if(mouseX>600&&mouseX<825&&mouseY>630&&mouseY<655&&marcador==2&&flaggraf==false) {
        flaggraf=true;
      }

      if(mouseX>596&&mouseX<645&&mouseY>110&&mouseY<125&&tpeca<tbanho+0.02f&&tpeca>tbanho-0.02f&&arot==0) { //liberarpe\u00e7atutorial
        flagpeca=true;
      }
    }

    else {

      if(mouseX>635&&mouseX<695&&mouseY>628&&mouseY<653) {
        goTutorial=false;
        flaginicio=false;
        marcador=1;
        controlevolta=1;
      }

      if(mouseX>730&&mouseX<810&&mouseY>628&&mouseY<653&&liberar==true) {
        tutorial=true;
        marcador=1;
      }

      if(mouseX>posgoX&&mouseX<posgoX+larggo&&mouseY>posgoY&&mouseY<posgoY+compgo&&goB==false&&xpeca<=0) {
        flaggo=true;
        
        energia=57.717f+59.939f*( ( exp((tpeca+2.166f)/60) - exp(-(tpeca+2.166f)/60) ) / ( exp((tpeca+2.166f)/60) + exp (-(tpeca+2.166f)/60) ) );
        if(energia>5) {
          energia= energia+random(-3,3);
        }
        if(flagpeca==false) {
          energia=0;
        }

        angfinal=(8*PI/12)*(1-(energia/200));
      }
      if(mouseX>posgoX&&mouseX<posgoX+larggo&&mouseY>posgoY&&mouseY<posgoY+compgo&&pausaB==false) {
        flagpausa=true;
      }
      if(mouseX>posgoX&&mouseX<posgoX+larggo+17&&mouseY>posgoY&&mouseY<posgoY+compgo&&estadoreplay==true) {

        estadoreplay=false;
        goB=false;
        arot=0;
        ypeca=0;
        xpeca=50;
        ang2=0;
        flagpeca=false;
        enAbs=0;
      }

      if(mouseX>595&&mouseX<645&&mouseY>110&&mouseY<125&&tpeca<tbanho+0.02f&&tpeca>tbanho-0.02f&&arot==0) { //liberarpe\u00e7a
        flagpeca=true;
      }
      if(mouseX>665&&mouseX<715&&mouseY>110&&mouseY<125&&abs(tpeca-tbanho)>0.02f&&arot==0) {
        flagalertatemp=true;
      }
    }
  }
}

public void keyPressed() {
  loop();
  tempoparado=tempop;
  if(goTutorial==true) {
    if (key == CODED) {
      tecla=keyCode;
      controlTemperaturaB(tecla);
    }
  }
}

float tempo=0;
float tempoant=0;
int controlcor=1;

class Button {

  boolean locmouseB;
  int cor1B;
  int cor2B;
  boolean flagB=false;
  float posBX; 
  float posBY; 
  float largB;
  float compB; 
  float tamfontB=10;
  String textob=" ";
  int pisca;

  Button(float posX, float posY, float larg,float comp, float tamfont, String texto) {
    posBX=posX; 
    posBY=posY; 
    largB=larg;
    compB=comp;
    tamfontB=tamfont; 
    textob=texto;
  }

  public void mostrar() {


    fill(150);

    if(mouseX>posBX&&mouseX<posBX+largB&&mouseY>posBY&&mouseY<posBY+compB) {
      locmouseB=true;
      fill(170);
      cor1B=190;
      cor2B=130;
    }
    else {
      locmouseB=false;
      cor1B=110;
      cor2B=170;
    }

    noStroke();
    rect(posBX,posBY,largB,compB);
    strokeWeight(3);
    strokeCap(ROUND);
    stroke(cor1B);
    line(posBX,posBY,posBX,posBY+compB);
    line(posBX,posBY+compB,posBX+largB,posBY+compB);
    stroke(cor2B);
    line(posBX,posBY,posBX+largB,posBY);
    line(posBX+largB,posBY,posBX+largB,posBY+compB);
    fill(0);
    textSize(tamfontB);
    textAlign(CENTER, CENTER);

    if(textob=="Novo teste") {

      if(controlcor==0) {
        if(tempo-tempoant>400) {
          tempoant=tempo;
          controlcor=1;
        }
        fill(255,0,0);
      }

      if(controlcor==1) {
        if(tempo-tempoant>400) {
          tempoant=tempo;
          controlcor=0;
        }
        fill(0);
      }
    }

    text(textob, posBX+(largB/2),posBY+(compB/2.5f));
    if(mouseX>posBX&&mouseX<posBX+largB&&mouseY>posBY&&mouseY<posBY+compB) {
      fill(170);
    }
  }
}

float ang2=0;
float xpeca=50;
float ypeca=0;

class Pendulo {

  public void update(float ang1) {

    pend.camera(width/2+400*sin(teta), 400,-50+400*cos(teta), width/2, 400, -30,0,1,0);

    pend.background(0);
    pend.beginDraw();
    pend.directionalLight(255, 255, 255, // Color
    -sin(teta), 0.5f, -cos(teta)); // Direction XYZ
    pend.pushMatrix();
    pend.translate(150,165,-50);
    pend.scale(0.8f);
    pend.fill(0xffA0CECE);
    pend.stroke(0);
    pend.strokeWeight(2);
    pend.pushMatrix();
    pend.translate(840/2-120, 560/2-60);
    pend.rotate(ang1);
    pend.translate(0,97.4f,-55);
    pend.box(40,190,20);  //bra\u00e7o
    pend.translate(5,102.6f,+15);

    pend.beginShape();                    //in\u00edciobra\u00e7o2
    pend.vertex(15,-7.5f,-25);
    pend.vertex(15,-7.5f,-5);
    pend.vertex(15,7.5f,-5);
    pend.vertex(15,7.5f,-25);
    pend.endShape(CLOSE);

    pend.beginShape();
    pend.vertex(15,-7.5f,-25);
    pend.vertex(15,7.5f,-25);
    pend.vertex(-25,7.5f,-15);
    pend.vertex(-25,-7.5f,-15);
    pend.endShape(CLOSE);
    pend.beginShape();
    pend.vertex(15,-7.5f,-5);
    pend.vertex(15,7.5f,-5);
    pend.vertex(-25,7.5f,-15);
    pend.vertex(-25,-7.5f,-15);
    pend.endShape(CLOSE);                              //fimbra\u00e7o2

    pend.translate(-5,15,-15);
    pend.box(40,15,20);                                 //bra\u00e7o3

    pend.popMatrix();

    pend.pushMatrix();
    pend.noStroke();
    pend.fill(200);
    pend.translate(300,472,-40);
    pend.box(100,40,130);                               //suporte
    pend.translate(0,-50,+12.5f);
    pend.box(20,60,30);                                //suportepe\u00e7a
    pend.translate(-5,0,-15);
    pend.box(10,5,5);

    pend.translate(+5,0,-40);
    pend.box(20,60,30);                               //suportepe\u00e7a2
    pend.translate(-5,0,15);
    pend.box(10,5,5);

    pend.fill(0xff6A6969); 

    pend.pushMatrix();

    if(flagpeca==true&&ypecal<19.5f&&xpeca>0&&ang1<-0.12f) {
      xpeca=xpeca-0.8f;
      flaggopeca=true;
      
      if(xpeca<0) {
        xpeca=0;
      }
    }

    if(flagpeca==true&&ypecal<19.5f&&xpeca<0.01f) {
      flaggopeca=false;
    }


    if(ang1>-0.12f) {

      pend.rotateY(ang2);
      if(ang2>-0.6f&&goB==true) {
        ang2=ang2-0.04f;
      }
      else {
        if(ypeca<27&&goB==true) {
          ypeca=ypeca+1.4f;
        }
      }
      if(ypeca<26&&goB==true) {
        xpeca=xpeca-0.8f;
      }
    }

    pend.translate(10+xpeca,0+ypeca,6.75f);
    if(flagpeca==true&&ypecal<20) {
      pend.box(10,5,12.5f);
    }    //pe\u00e7a1
    pend.popMatrix();


    pend.pushMatrix();
    pend.translate(0,0,25);
    if(ang1>-0.120f) {

      pend.rotateY(-ang2);
    }
    pend.translate(10+xpeca,0+ypeca,-6.5f);
    if(flagpeca==true&&ypecal<20) {
      pend.box(10,5,12.5f);                    //pe\u00e7a2
      pend.fill(0);
      pend.translate(-3,0,-5);
      if(ang1<-0.120f) {
        pend.box(5,5,3); // entalhe
      }
    }
    pend.popMatrix();


    pend.fill(255,0,0);
    pend.translate(2.5f,-86,-34);
    pend.box(40,300,6.7f);                             // arma\u00e7\u00e3oposte
    pend.translate(0,-120,20);
    pend.box(5,5,40);                               // pino

    pend.popMatrix();

    pend.pushMatrix();
    pend.fill(100);
    pend.translate(0,0,-42);
    pend.fill(255);
    pend.strokeWeight(4);
    pend.stroke(0);
    pend.ellipse(296, 216, 120,120);                //rel\u00f3gio

    pend.strokeWeight(1);
    pend.stroke(0);
    pend.line(296-60*sin(0),216+60*cos(0),0.5f, 296-50*sin(0),216+50*cos(0),0.5f);
    pend.line(296-60*sin(PI/12),216+60*cos(PI/12), 0.5f,296-50*sin(PI/12),216+50*cos(PI/12),0.5f);
    pend.line(296-60*sin(2*PI/12),216+60*cos(2*PI/12),0.5f, 296-50*sin(2*PI/12),216+50*cos(2*PI/12),0.5f);
    pend.line(296-60*sin(3*PI/12),216+60*cos(3*PI/12),0.5f, 296-50*sin(3*PI/12),216+50*cos(3*PI/12),0.5f);
    pend.line(296-60*sin(4*PI/12),216+60*cos(4*PI/12),0.5f, 296-50*sin(4*PI/12),216+50*cos(4*PI/12),0.5f);
    pend.line(296-60*sin(5*PI/12),216+60*cos(5*PI/12),0.5f, 296-50*sin(5*PI/12),216+50*cos(5*PI/12),0.5f);
    pend.line(296-60*sin(6*PI/12),216+60*cos(6*PI/12),0.5f, 296-50*sin(6*PI/12),216+50*cos(6*PI/12),0.5f);
    pend.line(296-60*sin(7*PI/12),216+60*cos(7*PI/12),0.5f, 296-50*sin(7*PI/12),216+50*cos(7*PI/12),0.5f);
    pend.line(296-60*sin(8*PI/12),216+60*cos(8*PI/12),0.5f, 296-50*sin(8*PI/12),216+50*cos(8*PI/12),0.5f);
    pend.translate(0,0,1);
    pend.image(zeroJoule, 257, 190);
    pend.image(duzJoule, 283, 250);
    pend.noStroke();
    pend.popMatrix();

    pend.pushMatrix();
    pend.translate(840/2-126, 560/2-63,-40.5f);

    if(arot+offset>0) {
      pend.rotate(arot+offset+0.05f);
    }
    pend.fill(0);
    pend.rect(0,0,3,45); //ponteiro
    pend.popMatrix();

    pend.popMatrix();
    pend.endDraw();
  }
}





public void controlTemperaturaB(int tec) {
if(flagpeca==false){
  if (tec==UP&&tbanho<=200) {
    tbanho=tbanho+0.1f;
    
  }
  if (tec==DOWN&&tbanho>=-120) {
    tbanho=tbanho-0.1f;
    
  }
  if (tec==RIGHT&&tbanho<=200) {
  
    tbanho=tbanho+1;
  }
  
  if (tec==LEFT&&tbanho>=-120) {
    tbanho=tbanho-1;
    
  }
  if(tbanho<-120){
    tbanho=-120;
  }
  if(tbanho>200){
    tbanho=200;
  }
}
}
public void controlTemperaturaP() {
  tpeca=tpeca-((tpeca-tbanho)/80);
}
float yterm=70;
int imagemcontrole=0;
float ypecal=100;
boolean flaggopeca=false;

public void menul() {
  menuL.beginDraw();
  menuL.translate(70,-20);
  menuL.background(0,50);
  menuL.noStroke();
  menuL.fill(0);
  menuL.rect(40,70,120,80); 
  menuL.fill(0xffC4C3C0);

menuL.textSize(12.5f);
menuL.image(setas,125,70,110,85);
menuL.text("- 0.1\u00b0C",160,170);
menuL.text("+ 0.1\u00b0C",160,80);
menuL.text("- 1.0\u00b0C",87,138);
menuL.text("+ 1.0\u00b0C",232,138);
menuL.textSize(14);
menuL.text("Amostra no banho", -35, 40);
menuL.text("         Controles para variar \n     a temperatura do banho", 90, 40);

  if(flagpeca==false) {
    menuL.rect(-5,100,50,15); //pe\u00e7a
ypecal=100;
    menuL.fill(0xff7E7E7E);
    menuL.rect(20,100,3,15);
  }

  if(flagpeca==true&&ypecal>20) {
    menuL.fill(0xffC4C3C0);
    menuL.rect(-5,ypecal,50,15); //pe\u00e7a
    
    menuL.fill(0xff7E7E7E);
    menuL.rect(20,ypecal,3,15);
  }
  
  if(flagpeca==true&&ypecal>19){
    flaggopeca=true;
    ypecal=ypecal-0.7f;
  }

  menuL.fill(0xff6496FF,130);
  menuL.rect(-30,70,100,80); //liqrecipiente
  menuL.stroke(255);
  menuL.line(-30,55,-30,150); //parederecipiente
  menuL.line(70,55,70,150); //parederecipiente
  menuL.line(-30,150,70,150); //parederecipiente



  //gelo
  if(imagemcontrole==1) { 
    menuL.stroke(0,0,255);
    menuL.strokeWeight(1.2f);
    menuL.fill(0xffDEF7F7);
    menuL.beginShape();
    menuL.vertex(-2, 145);
    menuL.vertex(12, 155);
    menuL.vertex(0, 170);
    menuL.vertex(-12, 157);
    menuL.endShape(CLOSE);
    menuL.beginShape();
    menuL.vertex(-2+18, 145-5);
    menuL.vertex(12+18, 155-5);
    menuL.vertex(0+18, 170-5);
    menuL.vertex(-12+18, 157-5);
    menuL.endShape(CLOSE);
    menuL.beginShape();
    menuL.vertex(-2+15, 145+3);
    menuL.vertex(12+15, 155+3);
    menuL.vertex(0+15, 170+3);
    menuL.vertex(-12+15, 157+3);
    menuL.endShape(CLOSE);
    menuL.beginShape();
    menuL.vertex(-2+33, 145-4);
    menuL.vertex(12+33, 155-4);
    menuL.vertex(0+33, 170-4);
    menuL.vertex(-12+33, 157-4);
    menuL.endShape(CLOSE);
    menuL.beginShape();
    menuL.vertex(-2+33, 145+7);
    menuL.vertex(12+33, 155+7);
    menuL.vertex(0+33, 170+7);
    menuL.vertex(-12+33, 157+7);
    menuL.endShape(CLOSE);
    menuL.beginShape();
    menuL.vertex(-2+50, 145);
    menuL.vertex(12+50, 155);
    menuL.vertex(0+50, 170);
    menuL.vertex(-12+50, 157);
    menuL.endShape(CLOSE);
  }

  //fogo

  if(imagemcontrole==2) {
    menuL.fill(0xffFCE319);
    menuL.stroke(0xffFA9E2D);
    menuL.ellipse(25,170,8,30);
    menuL.stroke(255);
    menuL.fill(100);
    menuL.rect(20,183,10,20);
  }

  menuL.translate(0,20);
  menuL.noStroke();
  menuL.fill(255);
  menuL.textFont(fonte1);
  menuL.textSize(20);
  menuL.text("Temperatura do banho :", -43,210);

  temperaturaBanho.setData(tbanho);
  temperaturaBanho.display();
  menuL.text("\u00b0C", 236,211);
  menuL.text(" Temperatura da pe\u00e7a   :", -43,255);
  temperaturaPeca.setData(tpeca);
  temperaturaPeca.display();
  menuL.text("\u00b0C", 236,256);
  menuL.text(" Energia absorvida :", -43,320);
  energiaAbs.setData(enAbs);
  energiaAbs.display();
  menuL.text("J", 198,321);
  menuL.textSize(15);
  menuL.text("Temperatura ( \u00b0C )", 60,575);
  menuL.rect(-15,395,280,160);
  menuL.text("Gr\u00e1fico da Energia Absorvida na ruptura\n      em fun\u00e7\u00e3o da tempertura da pe\u00e7a", -10, 360);
  menuL.textSize(11);
  menuL.text("-120", -29,570);
  menuL.text("200", 255,570);
  menuL.text("0", -28, 559);
  menuL.text("120", -37, 400);
  menuL.image(graf, -15,395);
  menuL.pushMatrix();
  menuL.fill(255);
  menuL.rotate(3*PI/2);
  menuL.textSize(14);
  menuL.text("Energia Absorvida (J) ", -544,-45);

  menuL.popMatrix();
  menuL.fill(255,0,0);
  if(flagalertatemp==true){
menuL.text("A pe\u00e7a ainda n\u00e3o atingiu a temperatura desejada.", -47,285);
  }
  menuL.strokeWeight(1);
  menuL.stroke(255,0,0);
  menuL.line( -15+ ((tbanho+120)*280/320),395, -15+ ((tbanho+120)*280/320),555);
  menuL.endDraw();
}

class Textbox { // 1-line simple textbox. ENTER will issue the typed data to the program and take out the focus
  PImage trickery; // background image to hide old text
  PGraphics textbox, border;

  int Border;
  int TWidth, THeight;
  int x, y;

  boolean OnFocus;

  String typed, cursorbuffer;    // text buffers
  int CursorCharIndex;
  int Fontsize;
  int TColour;
  float Margin; // in percentage (safer)
 
  Textbox(int _x, int _y, int _TWidth, int _THeight, String _defaulttext, int _Border, float _Margin, int _TColour) {
    x = _x; 
    y = _y; 
    TWidth = _TWidth; 
    THeight = _THeight;
    typed = cursorbuffer = _defaulttext;

    Border = _Border;

    textbox = createGraphics(TWidth - 2*Border, THeight - 2*Border, P2D);  // textbox area
    trickery = createImage(TWidth, THeight, RGB);    // background image

    border = createGraphics(TWidth, THeight, P2D);   // border
    OnFocus = false;
    CursorCharIndex = typed.length();
    CalculateFont();
    textbox.imageMode(CENTER);
    border.imageMode(CENTER);
    TColour = _TColour;
    Margin = _Margin;
    
  }

  public void CalculateFont() {
    Fontsize = THeight - 2*Border;
  }

  public void buildtrickery() {
    int i, px, py;
    int TMPColour, GETColour;

    trickery.loadPixels();
    for (i = 0; i < trickery.pixels.length; i++) {
      px = i%TWidth;
      py = i/TWidth;
      GETColour = menuL.get(x -PApplet.parseInt(TWidth/2) + (i % TWidth), y -PApplet.parseInt(THeight/2) + (i/TWidth));
      if ( (py < Border && py < px) || (px >= TWidth - Border && py <= px - (TWidth - THeight)) ) {
        TMPColour = lerpColor(color(0), GETColour, 0.8f);
      }
      else if (( py >= THeight - Border ) || ( px < Border )) {
        TMPColour = lerpColor(color(0), GETColour, 0.8f);
      }
      else TMPColour = GETColour;
      
      trickery.pixels[i] = color(0);
    }
    trickery.updatePixels();
  }

  public void KeyControl() {
    if (key == BACKSPACE && CursorCharIndex > 0) {
      typed = typed.substring(0, CursorCharIndex-1) + typed.substring(CursorCharIndex, typed.length());
      //cursorbuffer = typed.substring(0, CursorCharIndex-1);
      CursorCharIndex--;
      //cursorbuffer = typed.substring(0, CursorCharIndex);
    }
    else if (key == DELETE && CursorCharIndex < typed.length()) {
      typed = typed.substring(0, CursorCharIndex) + typed.substring(CursorCharIndex+1, typed.length());
      //cursorbuffer = typed.substring(0, CursorCharIndex);
    }
    else if (key != CODED && (key != ENTER && key != RETURN) && key != DELETE && key != BACKSPACE) {
      typed = typed.substring(0, CursorCharIndex) + key + typed.substring(CursorCharIndex, typed.length());
      CursorCharIndex++;
      //cursorbuffer = typed.substring(0, CursorCharIndex);
    }
    if (key == ENTER || key == RETURN) OnFocus = false;

    if (key == CODED) {
      switch(keyCode) {
      case LEFT:
        if (CursorCharIndex > 0) { 
          CursorCharIndex--; 
        }//cursorbuffer = typed.substring(0, CursorCharIndex); }
        break;
      case RIGHT:
        if (CursorCharIndex < typed.length()) { 
          CursorCharIndex++; 
        }//cursorbuffer = typed.substring(0, CursorCharIndex); }
        break;
      case KeyEvent.VK_END:
        CursorCharIndex = typed.length(); //cursorbuffer = typed.substring(0, CursorCharIndex);
        break;
      case KeyEvent.VK_HOME:
        CursorCharIndex = 0; //cursorbuffer = typed.substring(0, CursorCharIndex);
        break;
      }
    }
    cursorbuffer = typed.substring(0, CursorCharIndex);
  }

  public void keyPressed() {
    if (OnFocus) KeyControl();
    
  }

  public void mouseClicked() {
    float dx, dy;
    int i, besti;
    float prevcharpos, nextcharpos;

    dx = abs(mouseX - x); // > 0: to the right of center ; < 0: to the left of center
    dy = abs(mouseY - y);

    if (dx <= TWidth/2 && dy <= THeight/2) {
      OnFocus = true;
      if (typed.length() > 0) {
        prevcharpos = x + 5 - textbox.textWidth(typed)/2; 
        besti = -1;  // that +5 comes from the fact that ControlsW is at (5,5) (top left) in the global window
        for (i = 1; i < typed.length()+1 && besti == -1; i++) {
          nextcharpos = x + 5 - textbox.textWidth(typed)/2 + textbox.textWidth(typed.substring(0,i));
          if (abs(mouseX - nextcharpos) > abs(mouseX - prevcharpos)) besti = i-1;
          prevcharpos = nextcharpos;
        }
        if (besti == -1) besti = typed.length();
        CursorCharIndex = besti;
        cursorbuffer = typed.substring(0,besti);
      }
    }
    else OnFocus = false;
  }

  public void display() {
    textbox.beginDraw();
    TextOverlay();
    textbox.endDraw();
    menuL.image(border, x, y);
    menuL.image(textbox, x, y);
  }

  public void TextOverlay() {
    float cpos; // cursor position (x)
    textbox.pushMatrix();
    textbox.smooth();
    buildtrickery();
    border.image(trickery, TWidth/2, THeight/2);
    textbox.image(trickery, textbox.width/2, textbox.height/2);
    textbox.fill(TColour);
    textbox.textFont(fontButton, Fontsize);
    textbox.textAlign(CENTER, CENTER);

    cpos = textbox.width/2 + textbox.textWidth(typed)/2 - (textbox.textWidth(typed) - textbox.textWidth(cursorbuffer));

    if (cpos > 0.9f*textbox.width) textbox.translate(-(cpos - textbox.width + Margin*TWidth), 0);
    if (cpos < 0.1f*textbox.width) textbox.translate(-(cpos - textbox.width + (1 - Margin)*TWidth), 0);

    textbox.text(typed, textbox.width/2, textbox.height/2);
    textbox.stroke(0);
    if(OnFocus) {
      textbox.line(cpos, 0.1f*textbox.height, cpos, 0.9f*textbox.height);
    }
    if(!OnFocus) {
      CursorCharIndex = typed.length()/2; 
      cursorbuffer = typed.substring(0,CursorCharIndex);
    }
    textbox.popMatrix();
  }

  public String getText() {
    return typed;
  }

  public void setText(String _typed) {
    typed = cursorbuffer = _typed;
     CursorCharIndex = typed.length();
  }
}

class FloatNumberBox extends Textbox {
  float Data; // the floating-point number entered
  float MaxData, MinData, Epslon; // working range
  int digsleft, digsright; // formatting options; Digits to the left of decimal separator (Integer) and Digits to the right (Fractionary)

  FloatNumberBox(int _x, int _y, int _TWidth, int _THeight, float _defaultvalue, int _Border, 
  float _MaxData, float _MinData, float _Epslon, int _digsleft, int _digsright, float _Margin, int _TColour) {
    super (_x,_y,_TWidth,_THeight,"",_Border,_Margin,_TColour); // won't compile using the usual way. This is workaround
    MaxData = (_MaxData > 9.9999999999999999e37f) ? (9.9999999999999999e37f) : (_MaxData); // Avoid Infinity
    Epslon = (_Epslon < 1e-44f) ? (1e-44f) : (_Epslon); // Tolerance around zero (anything within this tolerance will be replaced by strict zero)
    MinData = (_MinData < -9.9999999999999999e37f) ? (-9.9999999999999999e37f) : (_MinData); // Avoid -Infinity
    digsleft = _digsleft;
    digsright = _digsright;
    Data = _defaultvalue; 
    typed = cursorbuffer = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
    CursorCharIndex = typed.length();
    if (Data > MaxData) {
      typed = (abs(MaxData) < 1.0e6f) ? (nfp(FloatRound(MaxData, digsright), digsleft, digsright)) : ( (MaxData > 0) ? ("+" + str(MaxData)) : (str(MaxData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MaxData;
    }
    if (Data < MinData) {
      typed = (abs(MinData) < 1.0e6f) ? (nfp(FloatRound(MinData, digsright), digsleft, digsright)) : ( (MinData > 0) ? ("+" + str(MinData)) : (str(MinData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MinData;
    }
    if (abs(Data) <= Epslon || str(Data).equals("NaN")) {
      typed = cursorbuffer = nfp(0, digsleft, digsright); 
      CursorCharIndex = typed.length(); 
      Data = 0;
    }
  }

  public float FloatRound(float number, float decimal) { // CAUTION: round() does not work with very big numbers (> 1e7). Probably stack overflow
    return (float)(round((number*pow(10, decimal))))/pow(10, decimal);
    
  }
  // http://processing.org/discourse/yabb2/YaBB.pl?num=1115073288
  public void keyPressed() {
    if (OnFocus) KeyFilter();
  }

  public void mouseClicked() {
    super.mouseClicked();
    if (!OnFocus) {
      typed = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
      CursorCharIndex = typed.length()/2; 
      cursorbuffer = typed.substring(0,CursorCharIndex);
    }
  }

  public void KeyFilter() { 
    /* Filter non-number characters and error checking
     basic error checking
     
     only call KeyControl() if everything is OK
     then, convert the typed string into a floating-point number
     */
    int i, j, dotpos, exppos;
    boolean errorflag = false;
    float DataIncrement;
    String TMP;

    switch(key) {
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case '0': 
      if (typed.length() > CursorCharIndex &&
        (typed.charAt(CursorCharIndex) == '+' || typed.charAt(CursorCharIndex) == '-' )) {
        errorflag = true;
      }
      // Avoid inserting number before "-" or "+"
    case CODED:
       switch(keyCode) {
      case UP: // fix: if textwidth changes(+ and -), update cursorbuffer    ;;    fix: exponent tweaking
        // find nearest dot or comma before current character to see whether the cursor stands over a non-integer part of the number
        dotpos = -1;  // if dotpos remains -1, is integer
        exppos = typed.length(); // if exppos remains typed.length(), there is no 'e' (CursorCharIndex cannot be bigger than this)
        for (i = 0; i < typed.length(); i++) {
          if (typed.charAt(i) == '.') dotpos = i;
          if (typed.charAt(i) == 'e' || typed.charAt(i) == 'E') exppos = i;
        }
        if (CursorCharIndex <= exppos) {
          if (dotpos == -1 && CursorCharIndex != 0) {
            DataIncrement = pow(10,typed.length() - CursorCharIndex);
          } 
          else {
            DataIncrement = (CursorCharIndex <= dotpos) ? (pow(10, -(CursorCharIndex - dotpos) )) : (pow(10, -(CursorCharIndex - dotpos - 1) ));
          }
          Data += (Data + DataIncrement < MaxData) ? (DataIncrement) : (0);
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        } 
        else {
          TMP = typed.substring(exppos+1, typed.length()); // get current exponent
          DataIncrement = pow(10, pow(10, TMP.length() +1 -(CursorCharIndex -exppos) ));
          if (TMP.charAt(0) == '-') { // negative exponent; rising will divide number
            Data /= DataIncrement;
          }
          else {
            Data *= DataIncrement;
          }
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        }
        break;
      case DOWN:
        // find nearest dot or comma before current character to see whether the cursor stands over a non-integer part of the number
        dotpos = -1;  // if dotpos remains -1, is integer
        exppos = typed.length(); // if exppos remains typed.length(), there is no 'e' (CursorCharIndex cannot be bigger than this)
        for (i = 0; i < typed.length(); i++) {
          if (typed.charAt(i) == '.') dotpos = i;
          if (typed.charAt(i) == 'e' || typed.charAt(i) == 'E') exppos = i;
        }
        if (CursorCharIndex <= exppos) {
          if (dotpos == -1 && CursorCharIndex != 0) {
            DataIncrement = pow(10,typed.length() - CursorCharIndex);
          } 
          else {
            DataIncrement = (CursorCharIndex <= dotpos) ? (pow(10, -(CursorCharIndex - dotpos) )) : (pow(10, -(CursorCharIndex - dotpos - 1) ));
          }
          Data -= (Data - DataIncrement > MinData) ? (DataIncrement) : (0);
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        } 
        else {
          TMP = typed.substring(exppos+1, typed.length()); // get current exponent
          DataIncrement = pow(10, pow(10, TMP.length() +1 -(CursorCharIndex -exppos) ));
          if (TMP.charAt(0) == '-') { // negative exponent; rising will multiply number
            Data *= DataIncrement;
          }
          else {
            Data /= DataIncrement;
          }
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        }

        break;
      default: 
        if (!errorflag) KeyControl(); 
        break;
      }
      break;
    case DELETE:
    
    case BACKSPACE:
      KeyControl();
      if (typed.length() == 0) {
        typed = "0.0"; 
        Data = 0; 
        cursorbuffer = "0"; 
        CursorCharIndex = 1;
      } // Avoid emptyness causing NaN
      if (CursorCharIndex > 1 && 
        (typed.charAt(CursorCharIndex - 1) == 'e' || typed.charAt(CursorCharIndex - 1) == 'E') && 
        typed.length() == CursorCharIndex) {
        typed += '0';
      } // Avoid 'e' and 'E' as last char
      if (CursorCharIndex > 1 && 
        CursorCharIndex == typed.length() && 
        (typed.charAt(CursorCharIndex - 1) == '+' || typed.charAt(CursorCharIndex - 1) == '-')) {
        typed += '0';
      } 
      // avoid '-' and '+' as last char
      if (typed.length() > CursorCharIndex &&
        (typed.charAt(0) == '+' || typed.charAt(0) == '-') &&
        (typed.charAt(CursorCharIndex) == '+' || typed.charAt(CursorCharIndex) == '-')) 
      {
        typed = typed.substring(0,CursorCharIndex) + typed.substring(CursorCharIndex+1,typed.length());
      }
      // Avoid "++" , "+-", "-+", and "--"; Avoid "+e", "-e", "+E", and "-E". Apagando e tinha notacao cientifica E sinal no numero
      // apagando um 'e', apaga tb o sinal q vem depois
      if (typed.length() > CursorCharIndex &&
        ((typed.charAt(0) == 'e' || typed.charAt(0) == 'E') || 
        ((typed.charAt(0) == '+' || typed.charAt(0) == '-') && 
        (typed.charAt(1) == 'e' || typed.charAt(1) == 'E' ) ) )) {
        typed = typed.substring(0,CursorCharIndex) + '1' + typed.substring(CursorCharIndex,typed.length()); 
        CursorCharIndex++; 
        cursorbuffer = typed.substring(0, CursorCharIndex);
      }
      // Avoid "e" or "E" as first char or as second char if first is "-" or "+"
      break;
    case '.':
      for(i = 0; i < typed.length(); i++) {
        if (typed.charAt(i) == '.') errorflag = true;
      }
      if (!errorflag) {
        KeyControl(); 
        Data = PApplet.parseFloat(typed);
      }
      break;
    case '+': // notacao cientifica: 1.34565e+10 e sinal: +1.23456e+10. Soh pode colocar fora da posicao de sinal se tiver o 'e'
      if (((typed.charAt(0) == '-' || typed.charAt(0) == '+') && 
        (CursorCharIndex == 1 || CursorCharIndex == 0)) ||
        ( CursorCharIndex > 0 &&
        ((typed.charAt(CursorCharIndex-1) != 'e' && typed.charAt(CursorCharIndex-1) != 'E')) ) ) {
        errorflag = true;
      }
      for (i = 1; i < typed.length(); i++) {
        if ((typed.charAt(i) == '+' || typed.charAt(i) == '-') &&
          CursorCharIndex != 0) {
          errorflag = true;
        }
      }
      if (!errorflag) {
        KeyControl();
      }
      break;
    case '-': // notacao cientifica: 1.2345e-10 e sinal: -12345e+10. Soh pode colocar fora da posicao de sinal se tiver o 'e'
      if (((typed.charAt(0) == '-' || typed.charAt(0) == '+') && 
        (CursorCharIndex == 1 || CursorCharIndex == 0)) ||
        ( CursorCharIndex > 0 &&
        ((typed.charAt(CursorCharIndex-1) != 'e' && typed.charAt(CursorCharIndex-1) != 'E')) ) ) {
        errorflag = true;
      } 
      // n pode colocar ++ ou +- ou -- ou -+ como sinal E nem colocar no meio se n tiver o 'e'
      for (i = 1; i < typed.length(); i++) {
        if ((typed.charAt(i) == '-' || typed.charAt(i) == '+') &&
          CursorCharIndex != 0) {
          errorflag = true;
        }
      }
      if (!errorflag) {
        KeyControl();
      }
      break;
    case 'e':
    case 'E':
      for (i = 1; i < typed.length(); i++) {
        if (typed.charAt(i) == 'e' || typed.charAt(i) == 'E') errorflag = true;
        if (CursorCharIndex < typed.length()) {
          for (j = CursorCharIndex; j < typed.length(); j++) {
            if (typed.charAt(j) == '.' || typed.charAt(j) == ',') errorflag = true;
          }
        }
      }
      if (!errorflag) {
        KeyControl();
        if (CursorCharIndex == typed.length()) typed += '0'; // avoid NaN errors
        if (CursorCharIndex == 1 || 
          (typed.charAt(CursorCharIndex - 2) == '+'
          || typed.charAt(CursorCharIndex - 2) == '-' )) {
          typed = typed.substring(0,CursorCharIndex-1) + '1' + typed.substring(CursorCharIndex-1,typed.length()); 
          CursorCharIndex++; 
          cursorbuffer = typed.substring(0, CursorCharIndex);
        }
      }
      break;
    case RETURN:
    case ENTER: 
      OnFocus = false; 
      
      break;
    }
    Data = PApplet.parseFloat(typed);
    if (Data > MaxData) {
      typed = cursorbuffer = (abs(MaxData) < 1.0e6f) ? (nfp(FloatRound(MaxData, digsright), digsleft, digsright)) : ( (MaxData > 0) ? ("+" + str(MaxData)) : (str(MaxData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MaxData;
    }
    if (Data < MinData) {
      typed = cursorbuffer = (abs(MinData) < 1.0e6f) ? (nfp(FloatRound(MinData, digsright), digsleft, digsright)) : ( (MinData > 0) ? ("+" + str(MinData)) : (str(MinData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MinData;
    }
    if (!OnFocus) {
      if (abs(Data) <= Epslon || str(Data).equals("NaN")) {
        typed = cursorbuffer = str(0); 
        CursorCharIndex = typed.length(); 
        Data = 0;
      }
      // round whatever is smaller than Epslon and if, with all the exhaustive error checking, the user is STILL able to NaN things up, fix
      
        else {
        typed = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
        CursorCharIndex = typed.length()/2; 
        cursorbuffer = typed.substring(0,CursorCharIndex);
      }
    }
  }

  public float getData() {
    return Data;
  }

  public void setData(float _Data) {
    Data = _Data;
    typed = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
    CursorCharIndex = typed.length()/2; 
    cursorbuffer = typed.substring(0,CursorCharIndex);
  }
}
public void funcaoVerMais(int casoVM) {
  noStroke();

  if(casoVM==-1) {

    Pend1.update(offset);
    image(pend,-210,50);
    fill(0,240);

    fill(255);
    rect(350,100,500,400);
    fill(0);

    textSize(30);
    text("TESTE DE IMPACTO CHARPY", 600,140);
    textSize(24);
    text("Nesta anima\u00e7\u00e3o descrevemos o \nfuncionamento de um ENSAIO DE \nIMPACTO POR P\u00caNDULO. A influ\u00eancia \nda temperatura na energia necess\u00e1ria \npara fraturar um corpo de prova e\n a Transi\u00e7\u00e3o D\u00factil - Fr\u00e1gil, s\u00e3o abordadas.", 600,310);
    noStroke();

    credito.mostrar();
    
    
    //EM REVIS\u00c3O
    fill(255,0,0);
    textSize(60);
    text("ANIMA\u00c7\u00c3O EM REVIS\u00c3O", 450,600);
    
  }

  if(casoVM==0) {

    Pend1.update(offset);
    image(pend,-210,50);
    fill(0,240);
    fill(0);

if(mousePressed==false){
  liberar=true;
}


    noStroke();
    image(inicial, 330,100);
    credito.mostrar();
  }
  if(casoVM==1) {
    fill(0,240);
    rect(0,0,width,height);
    fill(255,100);
    rect(150,100,600,500);
    fill(0);
    textSize(40);
    text("Cr\u00e9ditos", 450,140);
    textSize(12);
    textAlign(LEFT);
    text("Desenvolvimento: Jacqueline Cobiak Correia ( Aluna do 2\u00ba ano do Curso de Engenharia\n                                 Qu\u00edmica - Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo, \n"+
      "                                 S\u00e3o Paulo - SP, Brasil)\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia Metal\u00fargica\n                      e de Materiais, Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo,\n"+
      "                      S\u00e3o Paulo - SP, Brasil)"
      +"\n\nDesenvolvido em:  \n                                  "
      +"\n\nApoio: A simula\u00e7\u00e3o 'Ensaio de P\u00eandulo' foi desenvolvida no contexto do"+
      "\n             projeto 'Anima\u00e7\u00f5es para disciplinas Introdut\u00f3rias de Ci\u00eancia e"+
      "\n             Engenharia dos Materiais', integrante do 'Programa Ensinar com"+
      "\n             Pesquisa' da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o"+
      "\n             Paulo, \u00e0 qual expressamos nossos agradecimentos pela concess\u00e3o"+
      "\n             da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica (Projeto 2881 - ano 2011)."+
      "\n\n                                         \u00daltima atualiza\u00e7\u00e3o: 04/01/2013", 220,200);
    textAlign(CENTER);

    image(processing, 335,335,40,40);
    fill(0xff13059B);
    text("Processing",355,395);
    strokeWeight(1);
    stroke(0xff13059B);
    line(325,397,388,397);
    noStroke();
    fill(0xffF00F2D);
    rect(710,110,20,20);
    stroke(255);
    strokeWeight(2);
    line(713, 113, 727, 127);
    line(727, 113, 713, 127);
    noStroke();
    avancarref.mostrar();
  } 
  if(casoVM==2) {
    fill(0,240);
    rect(0,0,width,height);
    fill(255,100);
    rect(150,100,600,500);
    fill(0);
    textSize(40);
    text("Refer\u00eancias", 450,160);
    textSize(15);
    textAlign(LEFT);
    text("World Steel Association, MATTER, The University of Liverpool. 'Charpy Testing'\n<http://www.steeluniversity.org/content/html/eng/charpy-test.asp?>\nAcessado em 28 de abril de 2012\n\n"+
      "Godefroid, L. B.,C\u00e2ndido, L. C., Silva, J. G. A. ' Comportamento em fadiga de um\na\u00e7o estrutural patin\u00e1vel soldado'\n<http://www.scielo.br/scielo.php?script=sci_arttext&pid=S0370-44672002000200004>\n Acessado em 20 de maio de 2012\n\n"+
      "Centro de Informa\u00e7\u00e3o Metal Mec\u00e2nica. 'Teste Charpy'\n<http://www.cimm.com.br/portal/material_didatico/6582-teste-charpy>\nAcessado em 23 de maio de 2012", 180,250);
    textAlign(CENTER);
    fill(0xffF00F2D);
    rect(710,110,20,20);
    stroke(255);
    strokeWeight(2);
    line(713, 113, 727, 127);
    line(727, 113, 713, 127);
    noStroke();
    voltarcred.mostrar();
  }

  if(casoVM==3) {
    fill(0,240);
    rect(0,0,width,height);
      image(energia1,150,60);
      }

  if(casoVM==4) {
    fill(0,240);
    rect(0,0,width,height);
    image(corpoprova1, 70,70);
  }

  if(casoVM==10) {
    fill(0,240);
    rect(0,0,width,height);
    image(grafico1, 70,70);
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "pendulo3d6" });
  }
}
